"use strict";

/* exported logger */
/* exported Promise*/

var Panel = require('../Panel');
var UserPreferences = require('../../map/data/UserPreferences');
var GuiConnector = require('../../GuiConnector');

// noinspection JSUnusedLocalSymbols
var logger = require('../../logger');
var Functions = require('../../Functions');
var Promise = require("bluebird");

function AbstractAdminPanel(params) {
  params.scrollable = true;
  Panel.call(this, params);
  this._createHeader(params.name);

  this._initPromises = [];
}

AbstractAdminPanel.prototype = Object.create(Panel.prototype);
AbstractAdminPanel.prototype.constructor = AbstractAdminPanel;

AbstractAdminPanel.prototype._createHeader = function (name) {
  // this.getElement().appendChild(Functions.createElement({
  //   type: "h1",
  //   content: name
  // }));
};

AbstractAdminPanel.prototype.init = function () {
  return Promise.all(this._initPromises);
};

AbstractAdminPanel.prototype.bindUserGuiPreference = function (params) {

  params.jQueryObject.on(params.event, function () {
    return ServerConnector.getLoggedUser().then(function (user) {
      var oldValue = user.getPreferences().getGuiPreference(params.preferenceName, params.defaultValue);
      var newValue = params.getter();
      if (oldValue !== newValue) {
        user.getPreferences().setGuiPreference(params.preferenceName, newValue);

        var data = new UserPreferences();
        data.setGuiPreference(params.preferenceName, newValue);
        return ServerConnector.updateUserPreferences({user: user, preferences: data});
      }
    }).catch(GuiConnector.alert);
  });
  this._initPromises.push(ServerConnector.getLoggedUser().then(function (user) {
    var value = user.getPreferences().getGuiPreference(params.preferenceName, params.defaultValue);
    return params.setter(value);
  }));
};


module.exports = AbstractAdminPanel;
